MailMenuBarFixer = {}
MailMenuBarFixer.name = "MailMenuBarFixer"

local function fixer ()
    -- Not just mail any more!
    
    local scene = SCENE_MANAGER.currentScene.name
    local group = MAIN_MENU_KEYBOARD.sceneInfo[scene]

    if group == nil then return end

    local group_data = MAIN_MENU_KEYBOARD.sceneGroupInfo[group.sceneGroupName]
    
    if group_data == nil then return end

    local group_info = group_data.menuBarIconData
    local category = group_data.category

    local current = MAIN_MENU_KEYBOARD.sceneGroupBarLabel:GetText()

    local found = false

    for _,data in pairs(group_info) do
        if GetString(data.categoryName):upper() == current then
            found = true
        end
    end

    if found == false then
        CHAT_SYSTEM:AddMessage("[AutoMenuBarFixer] Found '" .. group.sceneGroupName .. "' using string '" .. current .. "'. Fixing!")

        MAIN_MENU_KEYBOARD:SetupSceneGroupBar(category, group.sceneGroupName)
    end
end

function MailMenuBarFixer.OnSceneChange (scene, oldState, newState)
    if newState ~= SCENE_SHOWING then
        return
    end

    fixer()
end

function MailMenuBarFixer:Initialize ()
    SCENE_MANAGER:RegisterCallback("SceneStateChanged", MailMenuBarFixer.OnSceneChange)
end

function MailMenuBarFixer.OnAddOnLoaded (event, name)
    if name == MailMenuBarFixer.name then
        MailMenuBarFixer:Initialize()
    end
end

SLASH_COMMANDS["/mmbf"] = fixer

EVENT_MANAGER:RegisterForEvent(MailMenuBarFixer.name, EVENT_ADD_ON_LOADED, MailMenuBarFixer.OnAddOnLoaded)
